<?php

namespace App\Http\Controllers\API;

use App\Http\Controllers\Controller;
use App\Libraries\BIM\BIMDriverEnum;
use App\Models\BimFile;
use App\Services\File\BimService;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Log;

class GlendaleController extends Controller
{
    public function callback(Request $request, BimService $bimService)
    {
        $data = $request->input('data', '');
        $arr = json_decode_arr($data);

        Log::info('glendale callback params:', $arr);

        $lightweightName = $arr['LightweightName'] ?? '';

        $bimFile = BimFile::where("bim_file_id", $lightweightName)
            ->where('bim_driver', BIMDriverEnum::GLENDALE->value)
            ->first();

        if (!$bimFile) {
            Log::info('no this glendale bim:', $lightweightName);
        } else {
            $bimService->storeBimInfo($bimFile);
        }

        return $this->success($arr);
    }
}
