<?php

namespace App\Libraries\ChunkedUpload;

use App\Libraries\ChunkedUpload\Contacts\ChunkedUploadContact;
use App\Libraries\ChunkedUpload\Disks\Cos;
use App\Libraries\ChunkedUpload\Disks\StandardDrive;

class ChunkedUploadFactory
{
    public static function make(string $disk = null): ChunkedUploadContact
    {
        $disk = $disk ?: config("filesystems.default");

        return match ($disk) {
            "cos" => new Cos(),
            default => new StandardDrive(),
        };
    }
}
